//Generated by the protocol buffer compiler. DO NOT EDIT!
// source: dsepractice/chinese/v1alpha1/core_types.proto

package gg.dsepractice.chinese.v1alpha1;

@kotlin.jvm.JvmName("-initializegameSessionData")
inline fun gameSessionData(block: gg.dsepractice.chinese.v1alpha1.GameSessionDataKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.GameSessionData =
  gg.dsepractice.chinese.v1alpha1.GameSessionDataKt.Dsl._create(gg.dsepractice.chinese.v1alpha1.GameSessionData.newBuilder()).apply { block() }._build()
object GameSessionDataKt {
  @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
  @com.google.protobuf.kotlin.ProtoDslMarker
  class Dsl private constructor(
    private val _builder: gg.dsepractice.chinese.v1alpha1.GameSessionData.Builder
  ) {
    companion object {
      @kotlin.jvm.JvmSynthetic
      @kotlin.PublishedApi
      internal fun _create(builder: gg.dsepractice.chinese.v1alpha1.GameSessionData.Builder): Dsl = Dsl(builder)
    }

    @kotlin.jvm.JvmSynthetic
    @kotlin.PublishedApi
    internal fun _build(): gg.dsepractice.chinese.v1alpha1.GameSessionData = _builder.build()

    /**
     * An uninstantiable, behaviorless type to represent the field in
     * generics.
     */
    @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
    class ParagraphsProxy private constructor() : com.google.protobuf.kotlin.DslProxy()
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     */
     val paragraphs: com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph, ParagraphsProxy>
      @kotlin.jvm.JvmSynthetic
      get() = com.google.protobuf.kotlin.DslList(
        _builder.getParagraphsList()
      )
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     * @param value The paragraphs to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("addParagraphs")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph, ParagraphsProxy>.add(value: gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph) {
      _builder.addParagraphs(value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     * @param value The paragraphs to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("plusAssignParagraphs")
    @Suppress("NOTHING_TO_INLINE")
    inline operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph, ParagraphsProxy>.plusAssign(value: gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph) {
      add(value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     * @param values The paragraphs to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("addAllParagraphs")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph, ParagraphsProxy>.addAll(values: kotlin.collections.Iterable<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph>) {
      _builder.addAllParagraphs(values)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     * @param values The paragraphs to add.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("plusAssignAllParagraphs")
    @Suppress("NOTHING_TO_INLINE")
    inline operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph, ParagraphsProxy>.plusAssign(values: kotlin.collections.Iterable<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph>) {
      addAll(values)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     * @param index The index to set the value at.
     * @param value The paragraphs to set.
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("setParagraphs")
    operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph, ParagraphsProxy>.set(index: kotlin.Int, value: gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph) {
      _builder.setParagraphs(index, value)
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Paragraph paragraphs = 1 [json_name = "paragraphs"];</code>
     */
    @kotlin.jvm.JvmSynthetic
    @kotlin.jvm.JvmName("clearParagraphs")
    fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph, ParagraphsProxy>.clear() {
      _builder.clearParagraphs()
    }
  }
  @kotlin.jvm.JvmName("-initializeparagraph")
  inline fun paragraph(block: gg.dsepractice.chinese.v1alpha1.GameSessionDataKt.ParagraphKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph =
    gg.dsepractice.chinese.v1alpha1.GameSessionDataKt.ParagraphKt.Dsl._create(gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph.newBuilder()).apply { block() }._build()
  object ParagraphKt {
    @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
    @com.google.protobuf.kotlin.ProtoDslMarker
    class Dsl private constructor(
      private val _builder: gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph.Builder
    ) {
      companion object {
        @kotlin.jvm.JvmSynthetic
        @kotlin.PublishedApi
        internal fun _create(builder: gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph.Builder): Dsl = Dsl(builder)
      }

      @kotlin.jvm.JvmSynthetic
      @kotlin.PublishedApi
      internal fun _build(): gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph = _builder.build()

      /**
       * An uninstantiable, behaviorless type to represent the field in
       * generics.
       */
      @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
      class SegmentsProxy private constructor() : com.google.protobuf.kotlin.DslProxy()
      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @return A list containing the segments.
       */
       val segments: com.google.protobuf.kotlin.DslList<kotlin.String, SegmentsProxy>
      @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
        get() = com.google.protobuf.kotlin.DslList(
          _builder.getSegmentsList()
        )
      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @param value The segments to add.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("addSegments")
      fun com.google.protobuf.kotlin.DslList<kotlin.String, SegmentsProxy>.add(value: kotlin.String) {
        _builder.addSegments(value)
      }
      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @param value The segments to add.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("plusAssignSegments")
      @Suppress("NOTHING_TO_INLINE")
      inline operator fun com.google.protobuf.kotlin.DslList<kotlin.String, SegmentsProxy>.plusAssign(value: kotlin.String) {
        add(value)
      }
      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @param values The segments to add.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("addAllSegments")
      fun com.google.protobuf.kotlin.DslList<kotlin.String, SegmentsProxy>.addAll(values: kotlin.collections.Iterable<kotlin.String>) {
        _builder.addAllSegments(values)
      }
      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @param values The segments to add.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("plusAssignAllSegments")
      @Suppress("NOTHING_TO_INLINE")
      inline operator fun com.google.protobuf.kotlin.DslList<kotlin.String, SegmentsProxy>.plusAssign(values: kotlin.collections.Iterable<kotlin.String>) {
        addAll(values)
      }
      /**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       * @param index The index to set the value at.
       * @param value The segments to set.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("setSegments")
      operator fun com.google.protobuf.kotlin.DslList<kotlin.String, SegmentsProxy>.set(index: kotlin.Int, value: kotlin.String) {
        _builder.setSegments(index, value)
      }/**
       * <code>repeated string segments = 1 [json_name = "segments"];</code>
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("clearSegments")
      fun com.google.protobuf.kotlin.DslList<kotlin.String, SegmentsProxy>.clear() {
        _builder.clearSegments()
      }
      /**
       * An uninstantiable, behaviorless type to represent the field in
       * generics.
       */
      @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
      class OptionsSequenceProxy private constructor() : com.google.protobuf.kotlin.DslProxy()
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       */
       val optionsSequence: com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option, OptionsSequenceProxy>
        @kotlin.jvm.JvmSynthetic
        get() = com.google.protobuf.kotlin.DslList(
          _builder.getOptionsSequenceList()
        )
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       * @param value The optionsSequence to add.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("addOptionsSequence")
      fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option, OptionsSequenceProxy>.add(value: gg.dsepractice.chinese.v1alpha1.GameSessionData.Option) {
        _builder.addOptionsSequence(value)
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       * @param value The optionsSequence to add.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("plusAssignOptionsSequence")
      @Suppress("NOTHING_TO_INLINE")
      inline operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option, OptionsSequenceProxy>.plusAssign(value: gg.dsepractice.chinese.v1alpha1.GameSessionData.Option) {
        add(value)
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       * @param values The optionsSequence to add.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("addAllOptionsSequence")
      fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option, OptionsSequenceProxy>.addAll(values: kotlin.collections.Iterable<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option>) {
        _builder.addAllOptionsSequence(values)
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       * @param values The optionsSequence to add.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("plusAssignAllOptionsSequence")
      @Suppress("NOTHING_TO_INLINE")
      inline operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option, OptionsSequenceProxy>.plusAssign(values: kotlin.collections.Iterable<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option>) {
        addAll(values)
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       * @param index The index to set the value at.
       * @param value The optionsSequence to set.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("setOptionsSequence")
      operator fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option, OptionsSequenceProxy>.set(index: kotlin.Int, value: gg.dsepractice.chinese.v1alpha1.GameSessionData.Option) {
        _builder.setOptionsSequence(index, value)
      }
      /**
       * <code>repeated .dsepractice.chinese.v1alpha1.GameSessionData.Option options_sequence = 2 [json_name = "optionsSequence"];</code>
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("clearOptionsSequence")
      fun com.google.protobuf.kotlin.DslList<gg.dsepractice.chinese.v1alpha1.GameSessionData.Option, OptionsSequenceProxy>.clear() {
        _builder.clearOptionsSequence()
      }

      /**
       * An uninstantiable, behaviorless type to represent the field in
       * generics.
       */
      @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
      class StartTipsProxy private constructor() : com.google.protobuf.kotlin.DslProxy()
      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @return A list containing the startTips.
       */
       val startTips: com.google.protobuf.kotlin.DslList<kotlin.String, StartTipsProxy>
      @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
        get() = com.google.protobuf.kotlin.DslList(
          _builder.getStartTipsList()
        )
      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @param value The startTips to add.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("addStartTips")
      fun com.google.protobuf.kotlin.DslList<kotlin.String, StartTipsProxy>.add(value: kotlin.String) {
        _builder.addStartTips(value)
      }
      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @param value The startTips to add.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("plusAssignStartTips")
      @Suppress("NOTHING_TO_INLINE")
      inline operator fun com.google.protobuf.kotlin.DslList<kotlin.String, StartTipsProxy>.plusAssign(value: kotlin.String) {
        add(value)
      }
      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @param values The startTips to add.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("addAllStartTips")
      fun com.google.protobuf.kotlin.DslList<kotlin.String, StartTipsProxy>.addAll(values: kotlin.collections.Iterable<kotlin.String>) {
        _builder.addAllStartTips(values)
      }
      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @param values The startTips to add.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("plusAssignAllStartTips")
      @Suppress("NOTHING_TO_INLINE")
      inline operator fun com.google.protobuf.kotlin.DslList<kotlin.String, StartTipsProxy>.plusAssign(values: kotlin.collections.Iterable<kotlin.String>) {
        addAll(values)
      }
      /**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       * @param index The index to set the value at.
       * @param value The startTips to set.
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("setStartTips")
      operator fun com.google.protobuf.kotlin.DslList<kotlin.String, StartTipsProxy>.set(index: kotlin.Int, value: kotlin.String) {
        _builder.setStartTips(index, value)
      }/**
       * <code>repeated string start_tips = 3 [json_name = "startTips"];</code>
       */
      @kotlin.jvm.JvmSynthetic
      @kotlin.jvm.JvmName("clearStartTips")
      fun com.google.protobuf.kotlin.DslList<kotlin.String, StartTipsProxy>.clear() {
        _builder.clearStartTips()
      }
      /**
       * <code>int32 sequence_size = 4 [json_name = "sequenceSize"];</code>
       */
      var sequenceSize: kotlin.Int
        @JvmName("getSequenceSize")
        get() = _builder.getSequenceSize()
        @JvmName("setSequenceSize")
        set(value) {
          _builder.setSequenceSize(value)
        }
      /**
       * <code>int32 sequence_size = 4 [json_name = "sequenceSize"];</code>
       */
      fun clearSequenceSize() {
        _builder.clearSequenceSize()
      }
    }
  }
  @kotlin.jvm.JvmName("-initializeoption")
  inline fun option(block: gg.dsepractice.chinese.v1alpha1.GameSessionDataKt.OptionKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.GameSessionData.Option =
    gg.dsepractice.chinese.v1alpha1.GameSessionDataKt.OptionKt.Dsl._create(gg.dsepractice.chinese.v1alpha1.GameSessionData.Option.newBuilder()).apply { block() }._build()
  object OptionKt {
    @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
    @com.google.protobuf.kotlin.ProtoDslMarker
    class Dsl private constructor(
      private val _builder: gg.dsepractice.chinese.v1alpha1.GameSessionData.Option.Builder
    ) {
      companion object {
        @kotlin.jvm.JvmSynthetic
        @kotlin.PublishedApi
        internal fun _create(builder: gg.dsepractice.chinese.v1alpha1.GameSessionData.Option.Builder): Dsl = Dsl(builder)
      }

      @kotlin.jvm.JvmSynthetic
      @kotlin.PublishedApi
      internal fun _build(): gg.dsepractice.chinese.v1alpha1.GameSessionData.Option = _builder.build()

      /**
       * <code>string content = 1 [json_name = "content"];</code>
       */
      var content: kotlin.String
        @JvmName("getContent")
        get() = _builder.getContent()
        @JvmName("setContent")
        set(value) {
          _builder.setContent(value)
        }
      /**
       * <code>string content = 1 [json_name = "content"];</code>
       */
      fun clearContent() {
        _builder.clearContent()
      }

      /**
       * <code>int32 position = 2 [json_name = "position"];</code>
       */
      var position: kotlin.Int
        @JvmName("getPosition")
        get() = _builder.getPosition()
        @JvmName("setPosition")
        set(value) {
          _builder.setPosition(value)
        }
      /**
       * <code>int32 position = 2 [json_name = "position"];</code>
       */
      fun clearPosition() {
        _builder.clearPosition()
      }
    }
  }
}
inline fun gg.dsepractice.chinese.v1alpha1.GameSessionData.copy(block: gg.dsepractice.chinese.v1alpha1.GameSessionDataKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.GameSessionData =
  gg.dsepractice.chinese.v1alpha1.GameSessionDataKt.Dsl._create(this.toBuilder()).apply { block() }._build()

inline fun gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph.copy(block: gg.dsepractice.chinese.v1alpha1.GameSessionDataKt.ParagraphKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.GameSessionData.Paragraph =
  gg.dsepractice.chinese.v1alpha1.GameSessionDataKt.ParagraphKt.Dsl._create(this.toBuilder()).apply { block() }._build()

inline fun gg.dsepractice.chinese.v1alpha1.GameSessionData.Option.copy(block: gg.dsepractice.chinese.v1alpha1.GameSessionDataKt.OptionKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.GameSessionData.Option =
  gg.dsepractice.chinese.v1alpha1.GameSessionDataKt.OptionKt.Dsl._create(this.toBuilder()).apply { block() }._build()

